//---------------------------------------------------------------------------
//
// Name:        Configuration.cpp
// Author:      Pradu Kannan
// Created:     6/15/2006 1:08:22 PM
// Description: 
//
//---------------------------------------------------------------------------

#include "Configuration.h"
#include <wx/filedlg.h>
#include <stdio.h>

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// Configuration
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(Configuration,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(Configuration::ConfigurationClose)
	EVT_BUTTON(ID_CANCEL,Configuration::CancelClick)
	EVT_BUTTON(ID_RESET,Configuration::ResetClick)
	EVT_BUTTON(ID_SAVE,Configuration::SaveClick)
	EVT_BUTTON(ID_BROWSE,Configuration::BrowseClick)
END_EVENT_TABLE()
////Event Table End

Configuration::Configuration(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
    CreateGUIControls();
    read();
}

Configuration::~Configuration() {} 

void Configuration::CreateGUIControls(void)
{
    //Do not add custom code here
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	wxBoxSizer* WxBoxSizer1 = new wxBoxSizer(wxVERTICAL);
	this->SetSizer(WxBoxSizer1);
	this->SetAutoLayout(TRUE);

	wxBoxSizer* WxBoxSizer2 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer1->Add(WxBoxSizer2,0,wxGROW | wxALL,5);

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Winboard/Xboard Exe"), wxPoint(5,9), wxSize(110,17), 0, wxT("WxStaticText1"));
	WxBoxSizer2->Add(WxStaticText1,0,wxALIGN_CENTER_VERTICAL | wxALL,5);

	WBexe = new wxTextCtrl(this, ID_WBEXE, wxT(""), wxPoint(125,7), wxSize(164,21), 0, wxDefaultValidator, wxT("WBexe"));
	WxBoxSizer2->Add(WBexe,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Browse = new wxButton(this, ID_BROWSE, wxT("Browse"), wxPoint(299,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Browse"));
	WxBoxSizer2->Add(Browse,0,wxALIGN_CENTER_VERTICAL | wxALL,5);

	wxBoxSizer* WxBoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer1->Add(WxBoxSizer3,0,wxGROW | wxALL,5);

	Save = new wxButton(this, ID_SAVE, wxT("Save"), wxPoint(5,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Save"));
	WxBoxSizer3->Add(Save,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Reset = new wxButton(this, ID_RESET, wxT("Reset"), wxPoint(90,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Reset"));
	WxBoxSizer3->Add(Reset,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Cancel = new wxButton(this, ID_CANCEL, wxT("Cancel"), wxPoint(175,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Cancel"));
	WxBoxSizer3->Add(Cancel,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	this->SetTitle(wxT("PSWBTM Configuration"));
	this->Center();
	this->SetIcon(wxNullIcon);
	
	////GUI Items Creation End
}

void Configuration::ConfigurationClose(wxCloseEvent& event)
{
    Destroy();
}
 

/*
 * BrowseClick
 */
void Configuration::BrowseClick(wxCommandEvent& event)
{
	wxFileDialog fd(this, wxT("Choose the Winboard/Xboard Executable"),wxT(""),wxT(""),wxT("Winboard Executable (*.exe)|*.exe|Other|*.*"),wxOPEN |wxFILE_MUST_EXIST);
	if(fd.ShowModal()==wxID_OK)
		WBexe->SetValue(fd.GetPath());
}

void Configuration::read()
{
	FILE* f=fopen(CONFIG_FILE,"r");
	char temp[4096];
	if(f==NULL) return;
	if(!fgets(temp,4096,f)) goto end;
	WBexe->SetValue(wxString(temp,*wxConvCurrent).RemoveLast());
end:
	fclose(f);
	return;
}

void Configuration::write()
{
	FILE* f=fopen(CONFIG_FILE,"w");
	if(f==NULL) return;
	fprintf(f,"%s\n",(WBexe->GetLineText(0)).c_str());
	fclose(f);
}

/*
 * CancelClick
 */
void Configuration::CancelClick(wxCommandEvent& event)
{
	Destroy();
}

/*
 * ResetClick
 */
void Configuration::ResetClick(wxCommandEvent& event)
{
	read();
}

/*
 * SaveClick
 */
void Configuration::SaveClick(wxCommandEvent& event)
{
	write();
	Destroy();
}
