//---------------------------------------------------------------------------
//
// Name:        Configuration.h
// Author:      Pradu Kannan
// Created:     6/15/2006 1:08:22 PM
// Description: 
//
//---------------------------------------------------------------------------

#ifndef __CONFIGURATION_h__
#define __CONFIGURATION_h__

#define CONFIG_FILE "config.pswbtm"

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
#include <wx/button.h>
#include <wx/textctrl.h>
#include <wx/stattext.h>
////Header Include End

//Compatibility for 2.4 code
#ifndef wxCLOSE_BOX
	#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
	#define wxFIXED_MINSIZE 0
#endif

////Dialog Style Start
#undef Configuration_STYLE
#define Configuration_STYLE wxCAPTION | wxRESIZE_BORDER | wxSYSTEM_MENU | wxTHICK_FRAME | wxDIALOG_NO_PARENT | wxMAXIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class Configuration : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		Configuration(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("PSWBTM Configuration"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = Configuration_STYLE);
		virtual ~Configuration();
	
	public:
		//Do not add custom control declarations
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxButton *Cancel;
		wxButton *Reset;
		wxButton *Save;
		wxBoxSizer *WxBoxSizer3;
		wxButton *Browse;
		wxTextCtrl *WBexe;
		wxStaticText *WxStaticText1;
		wxBoxSizer *WxBoxSizer2;
		wxBoxSizer *WxBoxSizer1;
		////GUI Control Declaration End
		
	public:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_CANCEL = 1009,
			ID_RESET = 1008,
			ID_SAVE = 1007,
			ID_BROWSE = 1005,
			ID_WBEXE = 1004,
			ID_WXSTATICTEXT1 = 1003,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		}; //End of Enum
	
	public:
		void ConfigurationClose(wxCloseEvent& event);
		void CreateGUIControls(void);
		void BrowseClick(wxCommandEvent& event);
		void read();
		void write();
		void CancelClick(wxCommandEvent& event);
		void ResetClick(wxCommandEvent& event);
		void SaveClick(wxCommandEvent& event);
};

#endif
