#include "Engine.h"

Engine::Engine()
{
	name=wxEmptyString;
	exe=wxEmptyString;
	parameters=wxEmptyString;
}

Engine::Engine(const wxString Ename, const wxFileName Eexe, const wxString Eparameters)
{
	name=Ename;
	exe=Eexe;
	parameters=Eparameters;
}

Engine::Engine(const wxString Ename, const wxString Eexe, const wxString Eparameters)
{
	name=Ename;
	exe=Eexe;
	parameters=Eparameters;
}

Engine::Engine(const Engine& e)
{
	operator=(e);
}

Engine& Engine::operator=(const Engine& e)
{
	name=e.name;
	exe=e.exe;
	parameters=e.parameters;
	return *this;
}

bool Engine::isInDir(const wxString dir, wxString* relativePath)
{
	return (exe.GetFullPath()).StartsWith(dir.c_str(), relativePath);
}

bool Engine::isValid()
{
	if(!(exe.GetFullName()).StartsWith("java") && !(exe.GetFullName()).StartsWith("Java")
		&& !(exe.GetFullName()).StartsWith("JAVA"))
		return exe.IsOk() && exe.FileExists();
	else
		return true;
}

void Engine::changeName(const wxString Ename)
{
	name=Ename;
}

void Engine::changeExe(const wxFileName Eexe)
{
	exe=Eexe;
}

void Engine::changeExe(const wxString Eexe)
{
	exe=Eexe;
}

void Engine::changeParameters(const wxString Eparameters)
{
	parameters=Eparameters;
}

wxString Engine::getWBParameters(int color)
{
	if(color==WHITE)
		return "-fd \"" + exe.GetPath() + "\" -fcp '\"./" + exe.GetFullName() + "\" " + parameters + "'";
	else
		return "-sd \"" + exe.GetPath() + "\" -scp '\"./" + exe.GetFullName() + "\" " + parameters + "'";
}

bool operator ==(const Engine& x, const Engine& y)
{
	return (x.name==y.name)/* || (x.exe==y.exe && x.parameters==y.parameters)*/;
}

bool operator !=(const Engine& x, const Engine& y)
{
	return x.name!=y.name;
}

bool operator >=(const Engine& x, const Engine& y)
{
	return x.name>=y.name;
}

bool operator <=(const Engine& x, const Engine& y)
{
	return x.name<=y.name;
}

bool operator <(const Engine& x, const Engine& y)
{
	return x.name<y.name;
}

bool operator >(const Engine& x, const Engine& y)
{
	return x.name>y.name;
}
