#ifndef __Engine
#define __Engine

#include <wx/string.h>
#include <wx/filename.h>

class Engine
{
	public:
		wxString name;
		wxFileName exe;
		wxString parameters;
			
		static const int WHITE=0;
		static const int BLACK=1;
		
		Engine();
		Engine(const wxString Ename, const wxFileName Eexe, const wxString Eparameters=wxEmptyString);
		Engine(const wxString Ename, const wxString Eexe, const wxString Eparameters=wxEmptyString);
		Engine(const Engine& e);
		Engine& operator=(const Engine& e);
		bool isInDir(const wxString dir, wxString* relativePath=NULL);
		bool isValid();
		void changeName(const wxString Ename);
		void changeExe(const wxFileName Eexe);
		void changeExe(const wxString Eexe);
		void changeParameters(const wxString Eparameters);
		wxString getWBParameters(int color);
		friend bool operator ==(const Engine& x, const Engine& y);
		friend bool operator !=(const Engine& x, const Engine& y);
		friend bool operator >=(const Engine& x, const Engine& y);
		friend bool operator <=(const Engine& x, const Engine& y);
		friend bool operator <(const Engine& x, const Engine& y);
		friend bool operator >(const Engine& x, const Engine& y);
};

#endif
