#ifndef __EngineList
#define __EngineList

#include "Engine.h"
#include <wx/ctrlsub.h>
#include <wx/string.h>
#include <wx/filename.h>
#include <stdio.h>

#include <vector>
#include <algorithm>
using namespace std;

#define DEFAULT_ENGINE_LIST_FILE "engines.pswbtm"
#define TOURNAMENT_ENGINE_LIST_FILE "tel.pswbtm"

class EngineList
{
	public:
		bool isSorted;
		vector<Engine> list;
		
		static const bool UNSORTED=false;
		static const bool SORTED=true;
		static const int MAX_LINE_LENGTH = 4096;
		
		EngineList(bool sorted=SORTED);
		EngineList(const EngineList& el);
		EngineList& operator =(const EngineList& el);
		
		void add(EngineList &el);
		void add(Engine &e);
		void remove(unsigned int index);
		void clear();
		unsigned int size();
		Engine& operator [](unsigned int index);
		Engine& get(unsigned int index);
		void sort();
		int find(Engine& e);
		int bestMatch(wxString& name);
		void updateControl(wxControlWithItems& lb);
		
		
		bool readDefaultFile();
		bool writeDefaultFile();
		bool readTournamentFile();
		bool writeTournamentFile();
		bool read(const wxString& fullFilePath);
		bool readWBINI(const wxString& fullFilePath);
		bool write(const wxString& fullFilePath);
};

#endif
