//---------------------------------------------------------------------------
//
// Name:        EngineManager.cpp
// Author:      Pradu Kannan
// Created:     6/12/2006 9:15:45 AM
// Description: 
//
//---------------------------------------------------------------------------

#include "EngineManager.h"
#include "Configuration.h"
#include <wx/dynarray.h>
#include <wx/filedlg.h>
#include <wx/filename.h>
#include <wx/msgdlg.h>
#include <wx/utils.h>
#include <wx/filefn.h>

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// EngineManager
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(EngineManager,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(EngineManager::EngineManagerClose)
	EVT_BUTTON(ID_FINISHNOSAVE,EngineManager::FinishNoSaveClick)
	EVT_BUTTON(ID_SELECTINVALID,EngineManager::SelectInvalidClick)
	EVT_BUTTON(ID_SELECTDUPLICATES,EngineManager::SelectDuplicatesClick)
	EVT_BUTTON(ID_LAUNCHENGINE,EngineManager::LaunchEngineClick)
	EVT_BUTTON(ID_FINISHSAVE,EngineManager::FinishSaveClick)
	EVT_BUTTON(ID_EXPORT,EngineManager::ExportClick)
	EVT_BUTTON(ID_IMPORT,EngineManager::ImportClick)
	EVT_BUTTON(ID_RESET,EngineManager::ResetClick)
	EVT_BUTTON(ID_SAVE,EngineManager::SaveClick)
	EVT_BUTTON(ID_BROWSE,EngineManager::BrowseClick)
	EVT_BUTTON(ID_DELETE,EngineManager::DeleteClick)
	EVT_BUTTON(ID_NEW,EngineManager::NewClick)
	EVT_LISTBOX(ID_ENGINELISTBOX,EngineManager::EngineListBoxSelected)
END_EVENT_TABLE()
////Event Table End

EngineManager::EngineManager(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	el.readDefaultFile();
    CreateGUIControls();
    el.updateControl(*EngineListBox);
    hasChanged=false;
}

EngineManager::~EngineManager() {} 

void EngineManager::CreateGUIControls(void)
{
    //Do not add custom code here
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	wxBoxSizer* WxBoxSizer1 = new wxBoxSizer(wxHORIZONTAL);
	this->SetSizer(WxBoxSizer1);
	this->SetAutoLayout(TRUE);

	wxBoxSizer* WxBoxSizer2 = new wxBoxSizer(wxVERTICAL);
	WxBoxSizer1->Add(WxBoxSizer2,3,wxGROW | wxALL,5);

	wxArrayString arrayStringFor_EngineListBox;
	EngineListBox = new wxListBox(this, ID_ENGINELISTBOX, wxPoint(5,5), wxSize(181,262), arrayStringFor_EngineListBox, wxLB_EXTENDED | wxVSCROLL | wxHSCROLL);
	WxBoxSizer2->Add(EngineListBox,1,wxGROW | wxALL,5);

	wxBoxSizer* WxBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer2->Add(WxBoxSizer4,0,wxGROW | wxALL,5);

	New = new wxButton(this, ID_NEW, wxT("New"), wxPoint(5,5), wxSize(75,25), 0, wxDefaultValidator, wxT("New"));
	WxBoxSizer4->Add(New,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Delete = new wxButton(this, ID_DELETE, wxT("Delete"), wxPoint(90,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Delete"));
	WxBoxSizer4->Add(Delete,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	wxBoxSizer* WxBoxSizer3 = new wxBoxSizer(wxVERTICAL);
	WxBoxSizer1->Add(WxBoxSizer3,4,wxGROW | wxALL,5);

	wxBoxSizer* WxBoxSizer5 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer3->Add(WxBoxSizer5,1,wxGROW | wxALL,0);

	LabelName = new wxStaticText(this, ID_LABELNAME, wxT("Name"), wxPoint(0,2), wxSize(32,17), 0, wxT("LabelName"));
	WxBoxSizer5->Add(LabelName,0,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Name = new wxTextCtrl(this, ID_NAME, wxT(""), wxPoint(32,0), wxSize(118,21), 0, wxDefaultValidator, wxT("Name"));
	WxBoxSizer5->Add(Name,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	wxBoxSizer* WxBoxSizer6 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer3->Add(WxBoxSizer6,1,wxGROW | wxALL,0);

	LabelExe = new wxStaticText(this, ID_LABELEXE, wxT("Exe"), wxPoint(0,4), wxSize(22,17), 0, wxT("LabelExe"));
	WxBoxSizer6->Add(LabelExe,0,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Exe = new wxTextCtrl(this, ID_EXE, wxT(""), wxPoint(22,2), wxSize(121,21), 0, wxDefaultValidator, wxT("Exe"));
	WxBoxSizer6->Add(Exe,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Browse = new wxButton(this, ID_BROWSE, wxT("Browse"), wxPoint(143,0), wxSize(45,25), 0, wxDefaultValidator, wxT("Browse"));
	WxBoxSizer6->Add(Browse,0,wxALIGN_CENTER_VERTICAL | wxALL,5);

	wxBoxSizer* WxBoxSizer7 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer3->Add(WxBoxSizer7,1,wxGROW | wxALL,0);

	LabelParameters = new wxStaticText(this, ID_LABELPARAMETERS, wxT("Parameters"), wxPoint(0,2), wxSize(57,17), 0, wxT("LabelParameters"));
	WxBoxSizer7->Add(LabelParameters,0,wxALIGN_CENTER_VERTICAL | wxALL,0);

	Parameters = new wxTextCtrl(this, ID_PARAMETERS, wxT(""), wxPoint(57,0), wxSize(121,21), 0, wxDefaultValidator, wxT("Parameters"));
	WxBoxSizer7->Add(Parameters,1,wxALIGN_CENTER_VERTICAL | wxALL,0);

	wxBoxSizer* WxBoxSizer8 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer3->Add(WxBoxSizer8,1,wxGROW | wxALL,5);

	Save = new wxButton(this, ID_SAVE, wxT("Save"), wxPoint(5,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Save"));
	WxBoxSizer8->Add(Save,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Reset = new wxButton(this, ID_RESET, wxT("Reset"), wxPoint(90,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Reset"));
	WxBoxSizer8->Add(Reset,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	wxBoxSizer* WxBoxSizer9 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer3->Add(WxBoxSizer9,1,wxGROW | wxALL,5);

	Import = new wxButton(this, ID_IMPORT, wxT("Import"), wxPoint(5,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Import"));
	WxBoxSizer9->Add(Import,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Export = new wxButton(this, ID_EXPORT, wxT("Export"), wxPoint(90,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Export"));
	WxBoxSizer9->Add(Export,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	FinishSave = new wxButton(this, ID_FINISHSAVE, wxT("Save Changes"), wxPoint(38,192), wxSize(121,25), 0, wxDefaultValidator, wxT("FinishSave"));
	WxBoxSizer3->Add(FinishSave,0,wxGROW | wxALL,5);

	LaunchEngine = new wxButton(this, ID_LAUNCHENGINE, wxT("Launch Engine"), wxPoint(20,227), wxSize(157,25), 0, wxDefaultValidator, wxT("LaunchEngine"));
	WxBoxSizer3->Add(LaunchEngine,0,wxGROW | wxALL,5);

	SelectDuplicates = new wxButton(this, ID_SELECTDUPLICATES, wxT("Select Duplicates"), wxPoint(37,262), wxSize(123,25), 0, wxDefaultValidator, wxT("SelectDuplicates"));
	WxBoxSizer3->Add(SelectDuplicates,0,wxGROW | wxALL,5);

	SelectInvalid = new wxButton(this, ID_SELECTINVALID, wxT("Select Invalid"), wxPoint(41,297), wxSize(116,25), 0, wxDefaultValidator, wxT("SelectInvalid"));
	WxBoxSizer3->Add(SelectInvalid,0,wxGROW | wxALL,5);

	FinishNoSave = new wxButton(this, ID_FINISHNOSAVE, wxT("Exit"), wxPoint(31,332), wxSize(135,25), 0, wxDefaultValidator, wxT("FinishNoSave"));
	WxBoxSizer3->Add(FinishNoSave,0,wxGROW | wxALL,5);

	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	this->SetTitle(wxT("Engine Manager"));
	this->Center();
	this->SetIcon(wxNullIcon);
	
	////GUI Items Creation End
}

void EngineManager::EngineManagerClose(wxCloseEvent& event)
{
	if(hasChanged)
	{
		if(wxYES==wxMessageBox(wxString("You have made some unsaved changes to the Engine Database.\nAre you sure you want to discard these changes?"),wxString("Exiting Engine Manager..."),wxYES_NO))
			Destroy();
	}
	else
		Destroy();
}
 

/*
 * EngineListBoxSelected
 */
void EngineManager::EngineListBoxSelected(wxCommandEvent& event)
{
	resetSelection();
}

void EngineManager::resetSelection()
{
	wxArrayInt selections;
	EngineListBox->GetSelections(selections);
	if(selections.Count()==1)
	{
		Engine e=el.get(selections.Item(0));
		Name->SetValue(e.name);
		Exe->SetValue((e.exe).GetFullPath());
		Parameters->SetValue(e.parameters);
	}
	else
	{
		Name->SetValue(wxEmptyString);
		Exe->SetValue(wxEmptyString);
		Parameters->SetValue(wxEmptyString);
	}
}

/*
 * BrowseClick
 */
void EngineManager::BrowseClick(wxCommandEvent& event)
{
	wxFileDialog fd(this, "Choose the Engine Executable","","","Windows Executables (*.exe)|*.exe|Other|*.*",wxOPEN |wxFILE_MUST_EXIST);
	if(fd.ShowModal()==wxID_OK)
		Exe->SetValue(fd.GetPath());
}

/*
 * NewClick
 */
void EngineManager::NewClick(wxCommandEvent& event)
{
	el.updateControl(*EngineListBox);
	resetSelection();
}

/*
 * DeleteClick
 */
void EngineManager::DeleteClick(wxCommandEvent& event)
{
	wxArrayInt selections;
	EngineListBox->GetSelections(selections);
	for(int i=selections.Count()-1; i>=0;i--)
	{
		el.remove(selections.Item(i));
		EngineListBox->Delete(selections.Item(i));
		hasChanged=true;
	}
	Name->SetValue(wxEmptyString);
	Exe->SetValue(wxEmptyString);
	Parameters->SetValue(wxEmptyString);
}

/*
 * SaveClick
 */
void EngineManager::SaveClick(wxCommandEvent& event)
{
	wxArrayInt selections;
	if(Name->GetLineText(0)==wxEmptyString)
		return;
	EngineListBox->GetSelections(selections);
	if(selections.Count()==1)
	{
		el[selections.Item(0)].changeName(Name->GetLineText(0));
		el[selections.Item(0)].changeExe(Exe->GetLineText(0));
		el[selections.Item(0)].changeParameters(Parameters->GetLineText(0));
		Engine e=el[selections.Item(0)];
		if(el.isSorted) el.sort();
		el.updateControl(*EngineListBox);
		EngineListBox->Select(el.find(e));
	}
	else
	{
		Engine e(Name->GetLineText(0),Exe->GetLineText(0),Parameters->GetLineText(0));
		el.add(e);
		Name->SetValue(wxEmptyString);
		Exe->SetValue(wxEmptyString);
		Parameters->SetValue(wxEmptyString);
		el.updateControl(*EngineListBox);
	}
	hasChanged=true;
}

/*
 * ImportClick
 */
void EngineManager::ImportClick(wxCommandEvent& event)
{
	wxFileDialog fd(this, "Choose the file to import engines from","","","PSWBTM Engine Export|*.pswbtmee|TSEM Winboard INI|winboard.ini",wxOPEN |wxFILE_MUST_EXIST);
	if(fd.ShowModal()==wxID_OK)
	{
		wxFileName fn(fd.GetPath());
		if(fn.GetExt()==wxString("pswbtmee"))
			el.read(fd.GetPath());
		else
			el.readWBINI(fd.GetPath());
		el.updateControl(*EngineListBox);
		hasChanged=true;
	}
}

/*
 * ExportClick
 */
void EngineManager::ExportClick(wxCommandEvent& event)
{
	wxFileDialog fd(this, "Choose the file to export engines to","","","PSWBTM Engine Export|*.pswbtmee|",wxSAVE |wxOVERWRITE_PROMPT);
	if(fd.ShowModal()==wxID_OK)
		el.write(fd.GetPath());
}

/*
 * SelectDuplicatesClick
 */
void EngineManager::SelectDuplicatesClick(wxCommandEvent& event)
{
	el.updateControl(*EngineListBox);
	unsigned int i,j;
	if(el.size())
		for(i=0;i<(el.size()-1);i++)
			for(j=i+1;j<el.size();j++)
				if(el[i]==el[j])
					EngineListBox->Select(j);
}

/*
 * SelectInvalidClick
 */
void EngineManager::SelectInvalidClick(wxCommandEvent& event)
{
	el.updateControl(*EngineListBox);
	for(unsigned int i=0;i<el.size();i++)
	{
		if(!el[i].isValid())
			EngineListBox->Select(i);
	}
}

/*
 * FinishSaveClick
 */
void EngineManager::FinishSaveClick(wxCommandEvent& event)
{
	el.writeDefaultFile();
	hasChanged=false;
}

/*
 * FinishNoSaveClick
 */
void EngineManager::FinishNoSaveClick(wxCommandEvent& event)
{
	if(hasChanged)
	{
		if(wxYES==wxMessageBox(wxString("You have made some unsaved changes to the Engine Database.\nAre you sure you want to discard these changes?"),wxString("Exiting Engine Manager..."),wxYES_NO|wxICON_QUESTION))
			Destroy();
	}
	else
		Destroy();
}

/*
 * ResetClick
 */
void EngineManager::ResetClick(wxCommandEvent& event)
{
	resetSelection();
}

/*
 * LaunchEngineClick
 */
void EngineManager::LaunchEngineClick(wxCommandEvent& event)
{
	wxArrayInt selections;
	EngineListBox->GetSelections(selections);
	wxFileName fn;
	wxString tempCwd;
	if(selections.Count()!=1)
	{
		wxMessageBox(wxString("Please select one and only one engine."),wxString("Incorrect number of selections!")/*,wxOk|wxICON_ERROR*/);
		return;
	}
	Engine e=el.get(selections.Item(0));
	FILE* f=fopen(CONFIG_FILE,"r");
	char temp[4096];
	if(f==NULL) goto error;
	if(!fgets(temp,4096,f)) {fclose(f); goto error;}
	fclose(f);
	printf("Removing Last ... ");
    fn=(wxString(temp).RemoveLast());
	printf("Yes\n Checking if File Exists ... ");
	#ifdef _WIN32
    if(!(fn.IsOk() && fn.FileExists())) goto error;
    #endif
    //printf("Yes\n Getting CWD ... ");
	//tempCwd=wxGetCwd();
	//printf("Yes\n Changing CWD ... ");
	//wxSetWorkingDirectory(fn.GetPath());
	printf("Yes\n Executing %s ... ",(fn.GetFullName()+" "+(e.getWBParameters(Engine::WHITE))+" "+(e.getWBParameters(Engine::BLACK))).c_str());
	wxExecute(fn.GetFullPath()+" -cp "+(e.getWBParameters(Engine::WHITE))+" "+(e.getWBParameters(Engine::BLACK)));
	//printf("Yes\n Reverting CWD ... ");
    //wxSetWorkingDirectory(tempCwd);
    //printf("Yes\n");
	return;
error:
	wxMessageBox(wxString("Please go to the configurations dialog and update the location of the Winboard/Xboard executable."),wxString("Winboard/Xboard not found!")/*,wxOk|wxICON_ERROR*/);
	return;
}
