//---------------------------------------------------------------------------
//
// Name:        EngineManager.h
// Author:      Pradu Kannan
// Created:     6/12/2006 9:15:45 AM
// Description: 
//
//---------------------------------------------------------------------------

#ifndef __ENGINEMANAGER_h__
#define __ENGINEMANAGER_h__

//Custom Headers
#include "EngineList.h"
//End Custom Headers

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
#include <wx/textctrl.h>
#include <wx/stattext.h>
#include <wx/button.h>
#include <wx/listbox.h>
////Header Include End

//Compatibility for 2.4 code
#ifndef wxCLOSE_BOX
	#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
	#define wxFIXED_MINSIZE 0
#endif

////Dialog Style Start
#undef EngineManager_STYLE
#define EngineManager_STYLE wxCAPTION | wxRESIZE_BORDER | wxSYSTEM_MENU | wxTHICK_FRAME | wxDIALOG_NO_PARENT | wxMAXIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class EngineManager : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		EngineManager(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("EngineManager"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = EngineManager_STYLE);
		virtual ~EngineManager();
	
	public:
		//Do not add custom control declarations
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxButton *FinishNoSave;
		wxButton *SelectInvalid;
		wxButton *SelectDuplicates;
		wxButton *LaunchEngine;
		wxButton *FinishSave;
		wxButton *Export;
		wxButton *Import;
		wxBoxSizer *WxBoxSizer9;
		wxButton *Reset;
		wxButton *Save;
		wxBoxSizer *WxBoxSizer8;
		wxTextCtrl *Parameters;
		wxStaticText *LabelParameters;
		wxBoxSizer *WxBoxSizer7;
		wxButton *Browse;
		wxTextCtrl *Exe;
		wxStaticText *LabelExe;
		wxBoxSizer *WxBoxSizer6;
		wxTextCtrl *Name;
		wxStaticText *LabelName;
		wxBoxSizer *WxBoxSizer5;
		wxBoxSizer *WxBoxSizer3;
		wxButton *Delete;
		wxButton *New;
		wxBoxSizer *WxBoxSizer4;
		wxListBox *EngineListBox;
		wxBoxSizer *WxBoxSizer2;
		wxBoxSizer *WxBoxSizer1;
		////GUI Control Declaration End
		EngineList el;
		bool hasChanged;
		
	public:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_FINISHNOSAVE = 1048,
			ID_SELECTINVALID = 1046,
			ID_SELECTDUPLICATES = 1038,
			ID_LAUNCHENGINE = 1049,
			ID_FINISHSAVE = 1047,
			ID_EXPORT = 1037,
			ID_IMPORT = 1036,
			ID_RESET = 1034,
			ID_SAVE = 1033,
			ID_PARAMETERS = 1030,
			ID_LABELPARAMETERS = 1029,
			ID_BROWSE = 1027,
			ID_EXE = 1023,
			ID_LABELEXE = 1022,
			ID_NAME = 1018,
			ID_LABELNAME = 1017,
			ID_DELETE = 1015,
			ID_NEW = 1014,
			ID_ENGINELISTBOX = 1005,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		}; //End of Enum
	
	public:
		void resetSelection();
		void EngineManagerClose(wxCloseEvent& event);
		void CreateGUIControls(void);
		void EngineListBoxSelected(wxCommandEvent& event);
		void BrowseClick(wxCommandEvent& event);
		void NewClick(wxCommandEvent& event);
		void DeleteClick(wxCommandEvent& event);
		void SaveClick(wxCommandEvent& event);
		void ImportClick(wxCommandEvent& event);
		void ExportClick(wxCommandEvent& event);
		void SelectDuplicatesClick(wxCommandEvent& event);
		void SelectInvalidClick(wxCommandEvent& event);
		void FinishSaveClick(wxCommandEvent& event);
		void FinishNoSaveClick(wxCommandEvent& event);
		void ResetClick(wxCommandEvent& event);
		void LaunchEngineClick(wxCommandEvent& event);
};

#endif
