//---------------------------------------------------------------------------
//
// Name:        NewTournament.cpp
// Author:      Pradu Kannan
// Created:     6/23/2006 2:33:25 PM
// Description: 
//
//---------------------------------------------------------------------------

#include "NewTournament.h"
#include "Tournament.h"
#include <wx/filedlg.h>
#include <wx/dirdlg.h>
#include <wx/progdlg.h>
#include <wx/generic/dirdlgg.h>
#include <wx/dynarray.h>
#include <wx/filename.h>
#include <wx/filefn.h>
#include <stdio.h>

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// NewTournament
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(NewTournament,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(NewTournament::NewTournamentClose)
	EVT_BUTTON(ID_CANCEL,NewTournament::CancelClick)
	EVT_BUTTON(ID_OK2,NewTournament::OkClick)
	
	EVT_LISTBOX_DCLICK(ID_AVAILABLE,NewTournament::AvailableDoubleClicked)
	EVT_BUTTON(ID_REMOVE,NewTournament::RemoveClick)
	EVT_BUTTON(ID_ADD,NewTournament::AddClick)
	
	EVT_LISTBOX_DCLICK(ID_PARTICIPANTS,NewTournament::ParticipantsDoubleClicked)
	EVT_BUTTON(ID_IPB,NewTournament::IPBClick)
	EVT_BUTTON(ID_IPBROWSE,NewTournament::IPBrowseClick)
	EVT_BUTTON(ID_SPBROWSE,NewTournament::SPBrowseClick)
	EVT_BUTTON(ID_DEBUGBROWSE,NewTournament::DEBUGBrowseClick)
	EVT_BUTTON(ID_RTPGNBROWSE,NewTournament::RTPGNBrowseClick)
	EVT_BUTTON(ID_PGNBROWSE,NewTournament::PGNBrowseClick)
END_EVENT_TABLE()
////Event Table End

NewTournament::NewTournament(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
    CreateGUIControls();
    el_gauntlet.readDefaultFile();
    el_participants=EngineList(EngineList::UNSORTED);
    el_available=el_gauntlet;
    el_available.updateControl(*Available);
    el_gauntlet.updateControl(*GauntletEngine);
}

NewTournament::~NewTournament() {} 

void NewTournament::CreateGUIControls(void)
{
    //Do not add custom code here
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxBoxSizer1 = new wxBoxSizer(wxVERTICAL);
	this->SetSizer(WxBoxSizer1);
	this->SetAutoLayout(true);

	WxBoxSizer18 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer1->Add(WxBoxSizer18, 0, wxEXPAND | wxALL, 0);

	WxStaticText12 = new wxStaticText(this, ID_WXSTATICTEXT12, wxT("Event Name"), wxPoint(2,4), wxDefaultSize, 0, wxT("WxStaticText12"));
	WxBoxSizer18->Add(WxStaticText12,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	EN = new wxTextCtrl(this, ID_EN, wxT(""), wxPoint(69,2), wxSize(121,21), 0, wxDefaultValidator, wxT("EN"));
	WxBoxSizer18->Add(EN,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	wxStaticBox* WxStaticBoxSizer1_StaticBoxObj = new wxStaticBox(this, wxID_ANY, wxT("File Settings"));
	WxStaticBoxSizer1 = new wxStaticBoxSizer(WxStaticBoxSizer1_StaticBoxObj, wxVERTICAL);
	WxBoxSizer1->Add(WxStaticBoxSizer1, 0, wxEXPAND | wxALL, 0);

	WxBoxSizer2 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer1->Add(WxBoxSizer2, 0, wxEXPAND | wxALL, 0);

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("PGN"), wxPoint(2,6), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxBoxSizer2->Add(WxStaticText1,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	PGN = new wxTextCtrl(this, ID_PGN, wxT("default.pgn"), wxPoint(33,4), wxSize(365,21), 0, wxDefaultValidator, wxT("PGN"));
	WxBoxSizer2->Add(PGN,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	PGNBrowse = new wxButton(this, ID_PGNBROWSE, wxT("Browse"), wxPoint(402,2), wxSize(48,25), 0, wxDefaultValidator, wxT("PGNBrowse"));
	WxBoxSizer2->Add(PGNBrowse,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxBoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer1->Add(WxBoxSizer3, 0, wxEXPAND | wxALL, 0);

	RTPGNBOOL = new wxCheckBox(this, ID_RTPGNBOOL, wxT("Result Table PGN"), wxPoint(2,6), wxSize(109,17), 0, wxDefaultValidator, wxT("RTPGNBOOL"));
	WxBoxSizer3->Add(RTPGNBOOL,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	RTPGN = new wxTextCtrl(this, ID_RTPGN, wxT(""), wxPoint(115,4), wxSize(285,21), 0, wxDefaultValidator, wxT("RTPGN"));
	WxBoxSizer3->Add(RTPGN,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	RTPGNBrowse = new wxButton(this, ID_RTPGNBROWSE, wxT("Browse"), wxPoint(404,2), wxSize(48,25), 0, wxDefaultValidator, wxT("RTPGNBrowse"));
	WxBoxSizer3->Add(RTPGNBrowse,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxBoxSizer4 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer1->Add(WxBoxSizer4, 0, wxEXPAND | wxALL, 0);

	DEBUGBOOL = new wxCheckBox(this, ID_DEBUGBOOL, wxT("Debug Folder"), wxPoint(2,6), wxSize(87,17), 0, wxDefaultValidator, wxT("DEBUGBOOL"));
	WxBoxSizer4->Add(DEBUGBOOL,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	DebugFolder = new wxTextCtrl(this, ID_DEBUGFOLDER, wxT(""), wxPoint(93,4), wxSize(305,21), 0, wxDefaultValidator, wxT("DebugFolder"));
	WxBoxSizer4->Add(DebugFolder,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	DEBUGBrowse = new wxButton(this, ID_DEBUGBROWSE, wxT("Browse"), wxPoint(402,2), wxSize(48,25), 0, wxDefaultValidator, wxT("DEBUGBrowse"));
	WxBoxSizer4->Add(DEBUGBrowse,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	wxStaticBox* WxStaticBoxSizer2_StaticBoxObj = new wxStaticBox(this, wxID_ANY, wxT("Tournament Type"));
	WxStaticBoxSizer2 = new wxStaticBoxSizer(WxStaticBoxSizer2_StaticBoxObj, wxVERTICAL);
	WxBoxSizer1->Add(WxStaticBoxSizer2, 0, wxEXPAND | wxALL, 0);

	WxBoxSizer5 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer2->Add(WxBoxSizer5, 0, wxEXPAND | wxALL, 0);

	Gauntlet = new wxRadioButton(this, ID_GAUNTLET, wxT("Gauntlet"), wxPoint(2,4), wxSize(63,17), wxRB_GROUP, wxDefaultValidator, wxT("Gauntlet"));
	Gauntlet->SetValue(true);
	WxBoxSizer5->Add(Gauntlet,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	wxArrayString arrayStringFor_GauntletEngine;
	GauntletEngine = new wxChoice(this, ID_GAUNTLETENGINE, wxPoint(69,2), wxSize(145,21), arrayStringFor_GauntletEngine, 0, wxDefaultValidator, wxT("GauntletEngine"));
	GauntletEngine->SetSelection(-1);
	WxBoxSizer5->Add(GauntletEngine,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxBoxSizer6 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer2->Add(WxBoxSizer6, 0, wxALIGN_LEFT | wxALL, 0);

	RoundRobin = new wxRadioButton(this, ID_ROUNDROBIN, wxT("Round Robin"), wxPoint(2,2), wxSize(90,17), 0, wxDefaultValidator, wxT("RoundRobin"));
	WxBoxSizer6->Add(RoundRobin,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxBoxSizer7 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer2->Add(WxBoxSizer7, 0, wxEXPAND | wxALL, 0);

	Swiss = new wxRadioButton(this, ID_SWISS, wxT("Swiss"), wxPoint(2,4), wxSize(49,17), 0, wxDefaultValidator, wxT("Swiss"));
	Swiss->Show(false);
	Swiss->Enable(false);
	WxBoxSizer7->Add(Swiss,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	SwissRounds = new wxSpinCtrl(this, ID_SWISSROUNDS, wxT("1"), wxPoint(55,2), wxSize(121,22),wxSP_WRAP, 1, 2147483647, 1);
	SwissRounds->Show(false);
	WxBoxSizer7->Add(SwissRounds,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxStaticText3 = new wxStaticText(this, ID_WXSTATICTEXT3, wxT("rounds"), wxPoint(180,4), wxDefaultSize, 0, wxT("WxStaticText3"));
	WxStaticText3->Show(false);
	WxBoxSizer7->Add(WxStaticText3,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxBoxSizer11 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer2->Add(WxBoxSizer11, 0, wxEXPAND | wxALL, 0);

	WxStaticText6 = new wxStaticText(this, ID_WXSTATICTEXT6, wxT("Games Per Pairing"), wxPoint(2,4), wxDefaultSize, 0, wxT("WxStaticText6"));
	WxBoxSizer11->Add(WxStaticText6,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	GPP = new wxSpinCtrl(this, ID_GPP, wxT("1"), wxPoint(97,2), wxSize(121,22),wxSP_WRAP, 1, 2147483647, 1);
	WxBoxSizer11->Add(GPP,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	wxStaticBox* WxStaticBoxSizer3_StaticBoxObj = new wxStaticBox(this, wxID_ANY, wxT("Time/Thinking Control"));
	WxStaticBoxSizer3 = new wxStaticBoxSizer(WxStaticBoxSizer3_StaticBoxObj, wxVERTICAL);
	WxBoxSizer1->Add(WxStaticBoxSizer3, 0, wxEXPAND | wxALL, 0);

	WxBoxSizer8 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer3->Add(WxBoxSizer8, 0, wxEXPAND | wxALL, 0);

	Fixed = new wxRadioButton(this, ID_FIXED, wxT("Fixed"), wxPoint(2,4), wxSize(48,17), wxRB_GROUP, wxDefaultValidator, wxT("Fixed"));
	Fixed->SetValue(true);
	WxBoxSizer8->Add(Fixed,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	FixedSeconds = new wxSpinCtrl(this, ID_FIXEDSECONDS, wxT("1"), wxPoint(54,2), wxSize(121,22),wxSP_WRAP, 1, 2147483647, 1);
	WxBoxSizer8->Add(FixedSeconds,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("seconds"), wxPoint(179,4), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxBoxSizer8->Add(WxStaticText2,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxBoxSizer9 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer3->Add(WxBoxSizer9, 0, wxEXPAND | wxALL, 0);

	Increment = new wxRadioButton(this, ID_INCREMENT, wxT("Increment"), wxPoint(2,4), wxSize(68,17), 0, wxDefaultValidator, wxT("Increment"));
	WxBoxSizer9->Add(Increment,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	IncrementMinutes = new wxSpinCtrl(this, ID_INCREMENTMINUTES, wxT("1"), wxPoint(74,2), wxSize(121,22),wxSP_WRAP, 1, 2147483647, 1);
	WxBoxSizer9->Add(IncrementMinutes,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT4, wxT("minutes"), wxPoint(199,4), wxDefaultSize, 0, wxT("WxStaticText4"));
	WxBoxSizer9->Add(WxStaticText4,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	IncrementIncrement = new wxSpinCtrl(this, ID_INCREMENTINCREMENT, wxT("0"), wxPoint(243,2), wxSize(121,22),wxSP_WRAP, 0, 2147483647, 0);
	WxBoxSizer9->Add(IncrementIncrement,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxStaticText5 = new wxStaticText(this, ID_WXSTATICTEXT5, wxT("second increment"), wxPoint(368,4), wxDefaultSize, 0, wxT("WxStaticText5"));
	WxBoxSizer9->Add(WxStaticText5,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxBoxSizer10 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer3->Add(WxBoxSizer10, 0, wxEXPAND | wxALL, 0);

	XY = new wxRadioButton(this, ID_XY, wxT("X moves Y minutes"), wxPoint(2,4), wxSize(110,17), 0, wxDefaultValidator, wxT("XY"));
	WxBoxSizer10->Add(XY,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	XYmoves = new wxSpinCtrl(this, ID_XYMOVES, wxT("1"), wxPoint(116,2), wxSize(121,22),wxSP_WRAP, 1, 2147483647, 1);
	WxBoxSizer10->Add(XYmoves,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxStaticText7 = new wxStaticText(this, ID_WXSTATICTEXT7, wxT("moves"), wxPoint(241,4), wxDefaultSize, 0, wxT("WxStaticText7"));
	WxBoxSizer10->Add(WxStaticText7,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	XYminutes = new wxSpinCtrl(this, ID_XYMINUTES, wxT("1"), wxPoint(280,2), wxSize(121,22),wxSP_WRAP, 1, 2147483647, 1);
	WxBoxSizer10->Add(XYminutes,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxStaticText8 = new wxStaticText(this, ID_WXSTATICTEXT8, wxT("minutes"), wxPoint(405,4), wxDefaultSize, 0, wxT("WxStaticText8"));
	WxBoxSizer10->Add(WxStaticText8,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxBoxSizer12 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer3->Add(WxBoxSizer12, 0, wxEXPAND | wxALL, 0);

	Pondering = new wxCheckBox(this, ID_PONDERING, wxT("Pondering"), wxPoint(2,4), wxSize(70,17), 0, wxDefaultValidator, wxT("Pondering"));
	WxBoxSizer12->Add(Pondering,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	FixedDepth = new wxCheckBox(this, ID_FIXEDDEPTH, wxT("Fixed Depth"), wxPoint(76,4), wxSize(79,17), 0, wxDefaultValidator, wxT("FixedDepth"));
	WxBoxSizer12->Add(FixedDepth,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	FixedDepthNum = new wxSpinCtrl(this, ID_FIXEDDEPTHNUM, wxT("1"), wxPoint(159,2), wxSize(121,22),wxSP_WRAP, 1, 2147483647, 1);
	WxBoxSizer12->Add(FixedDepthNum,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	wxStaticBox* WxStaticBoxSizer4_StaticBoxObj = new wxStaticBox(this, wxID_ANY, wxT("Starting Position"));
	WxStaticBoxSizer4 = new wxStaticBoxSizer(WxStaticBoxSizer4_StaticBoxObj, wxVERTICAL);
	WxBoxSizer1->Add(WxStaticBoxSizer4, 0, wxEXPAND | wxALL, 0);

	WxBoxSizer19 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer4->Add(WxBoxSizer19, 0, wxEXPAND | wxALL, 0);

	wxArrayString arrayStringFor_SPType;
	arrayStringFor_SPType.Add(wxT("Default Initial Position"));
	arrayStringFor_SPType.Add(wxT("FEN/EPD Position File"));
	arrayStringFor_SPType.Add(wxT("PGN File"));
	SPType = new wxChoice(this, ID_SPTYPE, wxPoint(2,4), wxSize(128,21), arrayStringFor_SPType, 0, wxDefaultValidator, wxT("SPType"));
	SPType->SetSelection(0);
	WxBoxSizer19->Add(SPType,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	SP = new wxTextCtrl(this, ID_SP, wxT(""), wxPoint(134,4), wxSize(121,21), 0, wxDefaultValidator, wxT("SP"));
	WxBoxSizer19->Add(SP,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	SPBrowse = new wxButton(this, ID_SPBROWSE, wxT("Browse"), wxPoint(259,2), wxSize(48,25), 0, wxDefaultValidator, wxT("SPBrowse"));
	WxBoxSizer19->Add(SPBrowse,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	wxStaticBox* WxStaticBoxSizer5_StaticBoxObj = new wxStaticBox(this, wxID_ANY, wxT("Initial Pairings Import"));
	WxStaticBoxSizer5 = new wxStaticBoxSizer(WxStaticBoxSizer5_StaticBoxObj, wxHORIZONTAL);
	WxBoxSizer1->Add(WxStaticBoxSizer5, 0, wxEXPAND | wxALL, 0);

	wxArrayString arrayStringFor_IPType;
	arrayStringFor_IPType.Add(wxT("PGN"));
	IPType = new wxChoice(this, ID_IPTYPE, wxPoint(7,19), wxSize(128,21), arrayStringFor_IPType, 0, wxDefaultValidator, wxT("IPType"));
	IPType->SetSelection(0);
	WxStaticBoxSizer5->Add(IPType,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	IP = new wxTextCtrl(this, ID_IP, wxT(""), wxPoint(139,19), wxSize(121,21), 0, wxDefaultValidator, wxT("IP"));
	WxStaticBoxSizer5->Add(IP,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	IPBrowse = new wxButton(this, ID_IPBROWSE, wxT("Browse"), wxPoint(264,17), wxSize(48,25), 0, wxDefaultValidator, wxT("IPBrowse"));
	WxStaticBoxSizer5->Add(IPBrowse,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	IPB = new wxButton(this, ID_IPB, wxT("Import"), wxPoint(316,17), wxSize(48,25), 0, wxDefaultValidator, wxT("IPB"));
	WxStaticBoxSizer5->Add(IPB,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	WxBoxSizer13 = new wxBoxSizer(wxVERTICAL);
	WxBoxSizer1->Add(WxBoxSizer13, 1, wxEXPAND | wxALL, 0);

	WxBoxSizer14 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer13->Add(WxBoxSizer14, 0, wxEXPAND | wxALL, 0);

	WxStaticText9 = new wxStaticText(this, ID_WXSTATICTEXT9, wxT("Participants"), wxPoint(2,2), wxDefaultSize, wxALIGN_CENTRE, wxT("WxStaticText9"));
	WxBoxSizer14->Add(WxStaticText9,1,wxEXPAND | wxALL,2);

	WxStaticText11 = new wxStaticText(this, ID_WXSTATICTEXT11, wxT(""), wxPoint(68,8), wxDefaultSize, 0, wxT("WxStaticText11"));
	WxBoxSizer14->Add(WxStaticText11,0,wxEXPAND | wxALL,5);

	WxStaticText10 = new wxStaticText(this, ID_WXSTATICTEXT10, wxT("Available"), wxPoint(79,2), wxDefaultSize, wxALIGN_CENTRE, wxT("WxStaticText10"));
	WxBoxSizer14->Add(WxStaticText10,1,wxEXPAND | wxALL,2);

	WxBoxSizer15 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer13->Add(WxBoxSizer15, 1, wxEXPAND | wxALL, 0);

	wxArrayString arrayStringFor_Participants;
	Participants = new wxListBox(this, ID_PARTICIPANTS, wxPoint(2,2), wxSize(121,150), arrayStringFor_Participants, wxLB_EXTENDED);
	WxBoxSizer15->Add(Participants,1,wxEXPAND | wxALL,2);

	WxBoxSizer16 = new wxBoxSizer(wxVERTICAL);
	WxBoxSizer15->Add(WxBoxSizer16, 0, wxEXPAND | wxALL, 0);

	Add = new wxButton(this, ID_ADD, wxT("<==="), wxPoint(2,2), wxSize(50,25), 0, wxDefaultValidator, wxT("Add"));
	WxBoxSizer16->Add(Add,1,wxEXPAND | wxALL,2);

	Remove = new wxButton(this, ID_REMOVE, wxT("===>"), wxPoint(2,31), wxSize(50,25), 0, wxDefaultValidator, wxT("Remove"));
	WxBoxSizer16->Add(Remove,1,wxEXPAND | wxALL,2);

	wxArrayString arrayStringFor_Available;
	Available = new wxListBox(this, ID_AVAILABLE, wxPoint(181,2), wxSize(121,150), arrayStringFor_Available, wxLB_EXTENDED);
	WxBoxSizer15->Add(Available,1,wxEXPAND | wxALL,2);

	WxBoxSizer17 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer1->Add(WxBoxSizer17, 0, wxALIGN_CENTER | wxALL, 0);

	Ok = new wxButton(this, ID_OK2, wxT("Ok"), wxPoint(2,2), wxSize(75,25), 0, wxDefaultValidator, wxT("Ok"));
	WxBoxSizer17->Add(Ok,1,wxALIGN_CENTER | wxALL,2);

	Cancel = new wxButton(this, ID_CANCEL, wxT("Cancel"), wxPoint(81,2), wxSize(75,25), 0, wxDefaultValidator, wxT("Cancel"));
	WxBoxSizer17->Add(Cancel,1,wxALIGN_CENTER | wxALL,2);

	WxBoxSizer20 = new wxBoxSizer(wxHORIZONTAL);
	WxStaticBoxSizer4->Add(WxBoxSizer20, 1, wxEXPAND | wxALL, 0);

	SPTwoGames = new wxCheckBox(this, ID_SPTWOGAMES, wxT("Two Games"), wxPoint(2,4), wxSize(78,17), 0, wxDefaultValidator, wxT("SPTwoGames"));
	WxBoxSizer20->Add(SPTwoGames,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	SPRewind = new wxCheckBox(this, ID_SPREWIND, wxT("Rewind"), wxPoint(84,4), wxSize(55,17), 0, wxDefaultValidator, wxT("SPRewind"));
	WxBoxSizer20->Add(SPRewind,0,wxALIGN_CENTER_VERTICAL | wxALL,2);

	SPRewindNum = new wxSpinCtrl(this, ID_SPREWINDNUM, wxT("1"), wxPoint(143,2), wxSize(121,22), wxSP_ARROW_KEYS, 1, 2147483647, 1);
	WxBoxSizer20->Add(SPRewindNum,1,wxALIGN_CENTER_VERTICAL | wxALL,2);

	SetTitle(wxT("New Tournament"));
	SetIcon(wxNullIcon);
	
	GetSizer()->Layout();
	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	Center();
	
	////GUI Items Creation End
	FILE* last_settings = fopen(LAST_SETTINGS_FILE,"rt");
	if(last_settings!=NULL)
	{
        //Format of the file (each variable in it's own line)
        char pgn_file_name[4096];
        char result_table_pgn_name[4096];
        char debug_folder_name[4096];
        char sp_file[4096];
        int result_table_checked;
        int debug_folder_checked;
        int tournament_type;
        int games_per_pairing;
        int time_control_type;
        int time_variable1;
        int time_variable2;
        int pondering_checked;
        int fixed_depth_value;
        int fixed_depth_checked;
        int sp_type;
        int sp_twogames;
        int sp_rewind;
        int sp_rewindNum;
        
        //get data
        fgets(pgn_file_name,4096,last_settings);
        pgn_file_name[strlen(pgn_file_name)-1]='\0';
        fgets(result_table_pgn_name,4096,last_settings);
        result_table_pgn_name[strlen(result_table_pgn_name)-1]='\0';
        fgets(debug_folder_name,4096,last_settings);
        debug_folder_name[strlen(debug_folder_name)-1]='\0';
        fgets(sp_file,4096,last_settings);
        sp_file[strlen(sp_file)-1]='\0';
        fscanf(last_settings,"%d\n",&result_table_checked);
        fscanf(last_settings,"%d\n",&debug_folder_checked);
        fscanf(last_settings,"%d\n",&tournament_type);
        fscanf(last_settings,"%d\n",&games_per_pairing);
        fscanf(last_settings,"%d\n",&time_control_type);
        fscanf(last_settings,"%d\n",&time_variable1);
        fscanf(last_settings,"%d\n",&time_variable2);
        fscanf(last_settings,"%d\n",&pondering_checked);
        fscanf(last_settings,"%d\n",&fixed_depth_value);
        fscanf(last_settings,"%d\n",&fixed_depth_checked);
        fscanf(last_settings,"%d\n",&sp_type);
        fscanf(last_settings,"%d\n",&sp_twogames);
        fscanf(last_settings,"%d\n",&sp_rewind);
        fscanf(last_settings,"%d\n",&sp_rewindNum);

        
        fclose(last_settings);
        
        //set data
        PGN->SetValue(pgn_file_name);
        RTPGN->SetValue(result_table_pgn_name);
        RTPGNBOOL->SetValue((bool)result_table_checked);
        DebugFolder->SetValue(debug_folder_name);
        DEBUGBOOL->SetValue((bool)debug_folder_checked);
        switch(tournament_type)
        {
            case Tournament::GAUNTLET:
            {
                Gauntlet->SetValue(true);
                RoundRobin->SetValue(false);
                Swiss->SetValue(false);
                break;
            }
            case Tournament::ROUND_ROBIN:
            {
                Gauntlet->SetValue(false);
                RoundRobin->SetValue(true);
                Swiss->SetValue(false);
                break;
            }
        }
        GPP->SetValue(games_per_pairing);
        switch(time_control_type)
        {
            case Tournament::TIME_CONTROL_FIXED:
            {
                Fixed->SetValue(true);
                Increment->SetValue(false);
                XY->SetValue(false);
                FixedSeconds->SetValue(time_variable1);
                break;
            }
            case Tournament::TIME_CONTROL_INCREMENT:
            {
                Fixed->SetValue(false);
                Increment->SetValue(true);
                XY->SetValue(false);
                IncrementMinutes->SetValue(time_variable1);
                IncrementIncrement->SetValue(time_variable2);
                break;
            }
            case Tournament::TIME_CONTROL_XY:
            {
                Fixed->SetValue(false);
                Increment->SetValue(false);
                XY->SetValue(true);
                XYminutes->SetValue(time_variable1);
                XYmoves->SetValue(time_variable2);
                break;
            }
        }
        Pondering->SetValue((bool)pondering_checked);
        FixedDepthNum->SetValue((bool)fixed_depth_value);
        FixedDepth->SetValue(fixed_depth_checked);
        SPType->SetSelection(sp_type);
        SP->SetValue(sp_file);
        SPTwoGames->SetValue((bool)sp_twogames);
        SPRewind->SetValue((bool)sp_rewind);
        SPRewindNum->SetValue(sp_rewindNum);
    }
}

void NewTournament::NewTournamentClose(wxCloseEvent& event)
{
    Destroy();
}
 

/*
 * CancelClick
 */
void NewTournament::CancelClick(wxCommandEvent& event)
{
	Destroy();
}

/*
 * PGNBrowseClick
 */
void NewTournament::PGNBrowseClick(wxCommandEvent& event)
{
	wxFileDialog fd(this, "Choose the PGN","","","Portable Game Notation (*.pgn)|*.pgn|Other|*.*",wxOPEN);
	if(fd.ShowModal()==wxID_OK)
	PGN->SetValue(fd.GetPath());
}

/*
 * RTPGNBrowseClick
 */
void NewTournament::RTPGNBrowseClick(wxCommandEvent& event)
{                                                                                                                   
	wxFileDialog fd(this, "Choose the result table PGN","","","Portable Game Notation (*.pgn)|*.pgn|Other|*.*",wxOPEN);
	if(fd.ShowModal()==wxID_OK)
	RTPGN->SetValue(fd.GetPath());
}

/*
 * DEBUGBrowseClick
 */
void NewTournament::DEBUGBrowseClick(wxCommandEvent& event)
{
	wxDirDialog dd(this, "Choose the debug folder", "", wxDD_NEW_DIR_BUTTON);
	if(dd.ShowModal()==wxID_OK)
	DebugFolder->SetValue(dd.GetPath());
}

/*
 * AddClick
 */
void NewTournament::AddClick(wxCommandEvent& event)
{
	wxArrayInt selections;
	Available->GetSelections(selections);
	for(int i=selections.Count()-1; i>=0;i--)
	{
		el_participants.add(el_available[selections.Item(i)]);
		el_available.remove(selections.Item(i));
		Available->Delete(selections.Item(i));
	}
	el_participants.updateControl(*Participants);
}

/*
 * RemoveClick
 */
void NewTournament::RemoveClick(wxCommandEvent& event)
{
	wxArrayInt selections;
	Participants->GetSelections(selections);
	for(int i=selections.Count()-1; i>=0;i--)
	{
		el_available.add(el_participants[selections.Item(i)]);
		el_participants.remove(selections.Item(i));
		Participants->Delete(selections.Item(i));
	}
	el_available.updateControl(*Available);
}

/*
 * AvailableDoubleClicked
 */
void NewTournament::AvailableDoubleClicked(wxCommandEvent& event)
{
	AddClick(event);
}

/*
 * ParticipantsDoubleClicked
 */
void NewTournament::ParticipantsDoubleClicked(wxCommandEvent& event)
{
	RemoveClick(event);
}

/*
 * OkClick
 */
void NewTournament::OkClick(wxCommandEvent& event)
{
	wxFileName fn;
	
	wxString PGN1=PGN->GetLineText(0);
	
	fn=PGN1;
	if(!fn.IsOk())
	{
		wxMessageBox(wxString("Bad PGN File"),wxString("Bad PGN"));
		return;
	}
	
	wxString RTPGN1=wxEmptyString;
	
	if(RTPGNBOOL->IsChecked())
	{
		RTPGN1=RTPGN->GetLineText(0);
		fn=RTPGN1;
		if(!fn.IsOk())
		{
			wxMessageBox(wxString("Bad Result Table PGN File"),wxString("Bad Result Table PGN"));
			return;
		}
	}
	
	wxString DEBUGFOLDER1=wxEmptyString;
	
	if(DEBUGBOOL->IsChecked())
	{
		DEBUGFOLDER1=DebugFolder->GetLineText(0);
		if(!wxDirExists(DEBUGFOLDER1))
		{
			wxMessageBox(wxString("The debug folder does not exist"),wxString("Bad Debug Folder"));
			return;
		}
	}
	
	int type1;
	if(Gauntlet->GetValue())
		type1=Tournament::GAUNTLET;
	else
		type1=Tournament::ROUND_ROBIN;
	
	int gamesPerPairing1=GPP->GetValue();
	
	int timeControlType;
	int TV1=1, TV2=0;
	
	if(Fixed->GetValue())
	{
		timeControlType=Tournament::TIME_CONTROL_FIXED;
		TV1=FixedSeconds->GetValue();
	}
	else if(Increment->GetValue())
	{
		timeControlType=Tournament::TIME_CONTROL_INCREMENT;
		TV1=IncrementMinutes->GetValue();
		TV2=IncrementIncrement->GetValue();
	}
	else
	{
		timeControlType=Tournament::TIME_CONTROL_XY;
		TV1=XYminutes->GetValue();
		TV2=XYmoves->GetValue();
	}
	
	bool pondering1=Pondering->IsChecked();
	
	if(el_participants.size()==0)
	{
		wxMessageBox(wxString("Sorry! You cannot have a tournament without participants!"),wxString("Bad Participant List"));
		return;
	}
	
	if(el_participants.size()==1 && type1==Tournament::ROUND_ROBIN)
	{
		wxMessageBox(wxString("Sorry! You cannot have a round robin tournament with only one participant!"),wxString("Bad Participant List"));
		return;
	}
	
	Engine GauntletEngine1;
	if(type1==Tournament::GAUNTLET)
	{
		int selection=GauntletEngine->GetSelection();
		if(selection==wxNOT_FOUND)
		{
			wxMessageBox(wxString("Sorry! You cannot have a gauntlet without a gauntlet engine!"),wxString("No Gauntlet Engine"));
			return;
		}
		GauntletEngine1=el_gauntlet[selection];
	}
	
	int setDepth1=0;
	if(FixedDepth->IsChecked())
		setDepth1=FixedDepthNum->GetValue();
	
	wxString TN=EN->GetLineText(0);
	
    int SP_type = SPType->GetSelection();
    if(SP_type==wxNOT_FOUND)
	{
		wxMessageBox(wxString("Please select a type of starting position!"),wxString("No Starting Position!"));
		return;
	}
	wxString SP_file = SP->GetLineText(0);
	
	if(SP_type!=Tournament::INITIAL_POSITION_DEFAULT && !wxFileExists(SP_file))
	{
		wxMessageBox(wxString("The position file does not exist"),wxString("Bad Position File"));
		return;
	}
	
	bool IP_twogames;
    int IP_rewindAfter;
	if(SP_type==Tournament::INITIAL_POSITION_DEFAULT)
	{
        IP_twogames = true;
        IP_rewindAfter = 0;
    }
    else
    {
        IP_twogames = SPTwoGames->IsChecked();
        if(!SPRewind->IsChecked()) IP_rewindAfter = 0;
        else
        {
            IP_rewindAfter = SPRewindNum->GetValue();
            if(IP_rewindAfter<=0)
            {
                wxMessageBox(wxString("The rewind parameter must be a positive integer."),wxString("Bad Rewind Parameter"));
		        return;
            }
        }
    }
	
	Tournament t(PGN1, RTPGN1, DEBUGFOLDER1, type1, gamesPerPairing1, timeControlType, TV1, TV2, pondering1, el_participants,GauntletEngine1, setDepth1,TN,SP_type,SP_file,IP_twogames,IP_rewindAfter);
	t.write();
	
	FILE* last_settings = fopen(LAST_SETTINGS_FILE,"wt");
	if(last_settings!=NULL)
	{
        //Format of the file (each variable in it's own line)
        fprintf(last_settings,"%s\n",PGN->GetLineText(0).c_str());
        fprintf(last_settings,"%s\n",RTPGN->GetLineText(0).c_str());
        fprintf(last_settings,"%s\n",DebugFolder->GetLineText(0).c_str());
        fprintf(last_settings,"%s\n",SP_file.c_str());
        fprintf(last_settings,"%d\n",(int)RTPGNBOOL->IsChecked());
        fprintf(last_settings,"%d\n",(int)DEBUGBOOL->IsChecked());
        fprintf(last_settings,"%d\n",type1);
        fprintf(last_settings,"%d\n",gamesPerPairing1);
        fprintf(last_settings,"%d\n",timeControlType);
        fprintf(last_settings,"%d\n",TV1);
        fprintf(last_settings,"%d\n",TV2);
        fprintf(last_settings,"%d\n",pondering1);
        fprintf(last_settings,"%d\n",FixedDepthNum->GetValue());
        fprintf(last_settings,"%d\n",(int)FixedDepth->IsChecked());
        fprintf(last_settings,"%d\n",SP_type);
        fprintf(last_settings,"%d\n",(int)SPTwoGames->IsChecked());
        fprintf(last_settings,"%d\n",(int)SPRewind->IsChecked());
        fprintf(last_settings,"%d\n",(int)SPRewindNum->GetValue());
        
        fclose(last_settings);
    }
	
	Destroy();
}

/*
 * SPBrowseClick
 */
void NewTournament::SPBrowseClick(wxCommandEvent& event)
{
	wxFileDialog fd(this, "Choose a stating position file","","","Starting Position Files (*.fen;*.epd;*.pgn)|*.fen;*.epd;*.pgn|Other|*.*",wxOPEN);
	if(fd.ShowModal()==wxID_OK)
	SP->SetValue(fd.GetPath());
}

/*
 * IPBrowseClick
 */
void NewTournament::IPBrowseClick(wxCommandEvent& event)
{
	wxFileDialog fd(this, "Choose a pairings data file","","","Pairings Data Files (*.pgn)|*.pgn|Other|*.*",wxOPEN);
	if(fd.ShowModal()==wxID_OK)
	IP->SetValue(fd.GetPath());
}

/*
 * IPBClick
 */
void NewTournament::IPBClick(wxCommandEvent& event)
{
    int IP_type = IPType->GetSelection();
	wxFileName fn = wxFileName(IP->GetLineText(0));
	if(!fn.IsOk())
	{
        badfile:                           


		wxMessageBox(wxString("Bad File"),wxString("Bad File"));
		return;
	}
	//Reset Engine Lists
	
	EngineList WhitePlayers(EngineList::UNSORTED);
    EngineList BlackPlayers(EngineList::UNSORTED);
    switch(IP_type)
    {
        
        //defined in NewTournament.h
        case INPUT_PAIRINGS_PGN_FILE:
            {
                FILE* f = fopen(fn.GetFullPath().c_str(),"rt");
                FILE* output = fopen("pairingsImport.txt","wt");
                if(f == NULL)
                    goto badfile;
                
                    
                fseek(f,0,SEEK_END);
                int progress_flags = wxPD_AUTO_HIDE|wxPD_SMOOTH|wxPD_CAN_ABORT|wxPD_ELAPSED_TIME|wxPD_REMAINING_TIME|wxPD_ESTIMATED_TIME;
                wxProgressDialog progress("Reading Pairing's File",wxString("Starting"),ftell(f),this,progress_flags);
                fseek(f,0,SEEK_SET);
                
                progress.Pulse("Resetting Engine Lists");
                el_available=el_gauntlet;
                el_participants.clear();
                el_available.updateControl(*Available);
                progress.Update(0,wxString("Reading ") + fn.GetFullPath().c_str());
                
                char line_char[4096];
                wxString WP; //white player
                wxString BP; //black player
                while(fgets(line_char,4096,f))
                {
                    progress.Update(ftell(f));
                    wxString line = wxString(line_char);
                    
                    if(line.StartsWith("[White \""))
                    {
                        if(line.EndsWith("\n")) line.RemoveLast(3);
                        else line.RemoveLast(2);
                        WP = line.Mid(8);
                    }
                    if(line.StartsWith("[Black \""))
                    {
                        if(line.EndsWith("\n")) line.RemoveLast(3);
                        else line.RemoveLast(2);
                        BP = line.Mid(8);
                    }
                    
                    if(!WP.IsEmpty() && !BP.IsEmpty())
                    {
                        fprintf(output,"%s - %s\n",WP.c_str(),BP.c_str());
                        if(el_available.size()<2)
                            goto end;
                        int index = el_available.bestMatch(WP);
                        fprintf(output,"Best Match (%s) = %s\n",WP.c_str(),el_available[index].name.c_str());
                        WP.Empty();
                        WhitePlayers.add(el_available[index]);
                        el_available.remove(index);
                        index = el_available.bestMatch(BP);
                        fprintf(output,"Best Match (%s) = %s\n",BP.c_str(),el_available[index].name.c_str());
                        BP.Empty();
                        BlackPlayers.add(el_available[index]);
                        el_available.remove(index);
                    }
                }
                fclose(f);
                fclose(output);
            }
    }
end:
    el_participants.add(WhitePlayers);
    for(int i=BlackPlayers.size()-1;i>=0;i--)
        el_participants.add(BlackPlayers[i]);
      
    el_participants.updateControl(*Participants);
    el_available.updateControl(*Available);
}
