//---------------------------------------------------------------------------
//
// Name:        PSWBTMApp.cpp
// Author:      Pradu Kannan
// Created:     6/11/2006 10:00:30 PM
// Description: 
//
//---------------------------------------------------------------------------

#include "PSWBTMApp.h"
#include "PSWBTMFrm.h"
#include <wx/snglinst.h>
#include <wx/log.h>

IMPLEMENT_APP(PSWBTMFrmApp)

wxSingleInstanceChecker* sic;

bool PSWBTMFrmApp::OnInit()
{
    wxString name = wxString::Format("PSWBTM");
    wxString path = wxGetCwd();

    sic = new wxSingleInstanceChecker(name,path);
	if (sic->IsAnotherRunning())
    {
        int answer = wxMessageBox(
            "Another instance of PSWBTM is running.  This could cause problems "
            "unless you know what you are doing.  Be sure that these two instances "
            "of PSWBTM are not using the same working directory, the same Winboard "
            "directory, or the same tournament directories.  Would you like to continue "
            "loading PSWBTM?","Multiple PSWBTM Instances Detected",wxYES_NO);
        if(answer==wxNO) return false;
        //wxLogError(_("You can only run one program instance of PSWBTM. Aborting..."));
    }
    PSWBTMFrm* frame = new PSWBTMFrm(NULL);
    SetTopWindow(frame);
    frame->Show(true);		
    return true;
}
 
int PSWBTMFrmApp::OnExit()
{
	delete sic;
	return 0;
}
