//---------------------------------------------------------------------------
//
// Name:        PSWBTMFrm.cpp
// Author:      Pradu Kannan
// Created:     6/11/2006 10:00:30 PM
// Description: 
//
//---------------------------------------------------------------------------

#include "PSWBTMFrm.h"
#include "Configuration.h"
#include "EngineManager.h"
#include "NewTournament.h"
#include <wx/filedlg.h>
#include <stdio.h>

#ifndef ID_PSWBTM_MAIN_WINDOW
#define ID_PSWBTM_MAIN_WINDOW 1000
#endif

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// PSWBTMFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(PSWBTMFrm,wxFrame)
	////Manual Code Start
	EVT_COMMAND(ID_PSWBTM_MAIN_WINDOW, wxEVT_UPDATE_INFO, PSWBTMFrm::updateInfo)
	////Manual Code End
	
	EVT_CLOSE(PSWBTMFrm::PSWBTMFrmClose)
	EVT_MENU(ID_MNU_FILE_EXIT_1002, PSWBTMFrm::Mnufileexit1002Click)
	EVT_MENU(ID_MNU__ENGINEMANAGER_1004, PSWBTMFrm::Mnuenginemanager1004Click)
	EVT_MENU(ID_MNU__TOURNAMENTMANAGER_CTRL_T_1007, PSWBTMFrm::Mnutournamentmanagerctrlt1007Click)
	EVT_MENU(ID_MNU__CONFIGURATION_F2_1008, PSWBTMFrm::Mnuconfigurationf21008Click)
	EVT_MENU(ID_MNU__SPLITPAIRINGWINDOWS_CTRL_S_1063, PSWBTMFrm::Mnusplitpairingwindowsctrls1063Click)
	EVT_MENU(ID_MNU__ABOUT_1010, PSWBTMFrm::Mnuabout1010Click)
	EVT_BUTTON(ID_RESET,PSWBTMFrm::EngineUpdatesSelected)
	EVT_BUTTON(ID_UPDATE,PSWBTMFrm::UpdateClick)
	EVT_BUTTON(ID_BROWSE,PSWBTMFrm::BrowseClick)
	EVT_LISTBOX(ID_ENGINEUPDATES,PSWBTMFrm::EngineUpdatesSelected)
	EVT_TOGGLEBUTTON(ID_PER,PSWBTMFrm::PERClick)
	EVT_BUTTON(ID_ABORT,PSWBTMFrm::AbortClick)
	EVT_BUTTON(ID_KILLPAUSE,PSWBTMFrm::KillPauseClick)
	EVT_BUTTON(ID_PR,PSWBTMFrm::PauseClick)
	EVT_LISTBOX(ID_ROUNDS,PSWBTMFrm::RoundsSelected)
END_EVENT_TABLE()
////Event Table End

PSWBTMFrm::PSWBTMFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
	/*Pairings->InsertColumn(0,"#",wxLIST_FORMAT_LEFT,40);
	Pairings->InsertColumn(1,"First Chess Engine",wxLIST_FORMAT_LEFT,120);
	Pairings->InsertColumn(2,"Second Chess Engine",wxLIST_FORMAT_LEFT,120);*/
	t.makeDaddy(this);
	t.read();
	(t.Participants).updateControl(*EngineUpdates);
	updateGUI();
}

PSWBTMFrm::~PSWBTMFrm() {}

void PSWBTMFrm::CreateGUIControls(void)
{
	//Do not add custom code here
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxBoxSizer1 = new wxBoxSizer(wxHORIZONTAL);
	this->SetSizer(WxBoxSizer1);
	this->SetAutoLayout(true);

	Notebook = new wxNotebook(this, ID_NOTEBOOK, wxPoint(0,0),wxSize(462,350));
	WxBoxSizer1->Add(Notebook,1,wxEXPAND | wxALL,0);

	ParingsPage = new wxPanel(Notebook, ID_PARINGSPAGE, wxPoint(4,24), wxSize(454,322));
	Notebook->AddPage(ParingsPage, wxT("Parings"));

	WxBoxSizer2 = new wxBoxSizer(wxVERTICAL);
	ParingsPage->SetSizer(WxBoxSizer2);
	ParingsPage->SetAutoLayout(true);

	WxSplitterWindow1 =new wxSplitterWindow(ParingsPage, ID_WXSPLITTERWINDOW1, wxPoint(0,0), wxSize(446,160) , wxSP_BORDER);
	WxBoxSizer2->Add(WxSplitterWindow1,1,wxEXPAND | wxALL,0);

	wxArrayString arrayStringFor_Rounds;
	Rounds = new wxListBox(WxSplitterWindow1, ID_ROUNDS, wxPoint(81,5), wxSize(137,139), arrayStringFor_Rounds, wxLB_SINGLE);

	Pairings = new wxListCtrl(WxSplitterWindow1, ID_PAIRINGS, wxPoint(5,154), wxSize(289,150), wxLC_REPORT);
	Pairings->InsertColumn(0,wxT("Second Chess Engine"),wxLIST_FORMAT_LEFT,120 );
	Pairings->InsertColumn(0,wxT("First Chess Engine"),wxLIST_FORMAT_LEFT,120 );
	Pairings->InsertColumn(0,wxT("#"),wxLIST_FORMAT_LEFT,40 );

	StandingsPage = new wxPanel(Notebook, ID_STANDINGSPAGE, wxPoint(4,24), wxSize(454,322));
	Notebook->AddPage(StandingsPage, wxT("Standings"));

	WxBoxSizer10 = new wxBoxSizer(wxHORIZONTAL);
	StandingsPage->SetSizer(WxBoxSizer10);
	StandingsPage->SetAutoLayout(true);

	Standings = new wxListCtrl(StandingsPage, ID_STANDINGS, wxPoint(5,5), wxSize(441,315), wxLC_REPORT);
	Standings->InsertColumn(0,wxT("%"),wxLIST_FORMAT_LEFT,50 );
	Standings->InsertColumn(0,wxT("Games"),wxLIST_FORMAT_LEFT,72 );
	Standings->InsertColumn(0,wxT("Points"),wxLIST_FORMAT_LEFT,75 );
	Standings->InsertColumn(0,wxT("Name"),wxLIST_FORMAT_LEFT,193 );
	Standings->InsertColumn(0,wxT("#"),wxLIST_FORMAT_LEFT,40 );
	WxBoxSizer10->Add(Standings,1,wxEXPAND | wxALL,5);

	ControlsPage = new wxPanel(Notebook, ID_CONTROLSPAGE, wxPoint(4,24), wxSize(454,322));
	Notebook->AddPage(ControlsPage, wxT("Controls"));

	WxBoxSizer3 = new wxBoxSizer(wxVERTICAL);
	ControlsPage->SetSizer(WxBoxSizer3);
	ControlsPage->SetAutoLayout(true);

	wxStaticBox* WxStaticBoxSizer1_StaticBoxObj = new wxStaticBox(ControlsPage, wxID_ANY, wxT("Tournament Controls"));
	WxStaticBoxSizer1 = new wxStaticBoxSizer(WxStaticBoxSizer1_StaticBoxObj, wxHORIZONTAL);
	WxBoxSizer3->Add(WxStaticBoxSizer1, 0, wxEXPAND | wxALL, 5);

	PR = new wxButton(ControlsPage, ID_PR, wxT("Start"), wxPoint(10,20), wxSize(75,25), 0, wxDefaultValidator, wxT("PR"));
	WxStaticBoxSizer1->Add(PR,1,wxEXPAND | wxALL,5);

	KillPause = new wxButton(ControlsPage, ID_KILLPAUSE, wxT("Kill Pause"), wxPoint(95,20), wxSize(75,25), 0, wxDefaultValidator, wxT("KillPause"));
	WxStaticBoxSizer1->Add(KillPause,1,wxEXPAND | wxALL,5);

	Abort = new wxButton(ControlsPage, ID_ABORT, wxT("Abort"), wxPoint(180,20), wxSize(75,25), 0, wxDefaultValidator, wxT("Abort"));
	WxStaticBoxSizer1->Add(Abort,1,wxEXPAND | wxALL,5);

	PER = new wxToggleButton(ControlsPage, ID_PER, wxT("Round Pause"), wxPoint(265,20), wxSize(75,25), 0, wxDefaultValidator, wxT("PER"));
	WxStaticBoxSizer1->Add(PER,1,wxEXPAND | wxALL,5);

	wxStaticBox* WxStaticBoxSizer2_StaticBoxObj = new wxStaticBox(ControlsPage, wxID_ANY, wxT("Engine Updates"));
	WxStaticBoxSizer2 = new wxStaticBoxSizer(WxStaticBoxSizer2_StaticBoxObj, wxHORIZONTAL);
	WxBoxSizer3->Add(WxStaticBoxSizer2, 1, wxEXPAND | wxALL, 5);

	wxArrayString arrayStringFor_EngineUpdates;
	EngineUpdates = new wxListBox(ControlsPage, ID_ENGINEUPDATES, wxPoint(10,52), wxSize(121,97), arrayStringFor_EngineUpdates, wxLB_SINGLE);
	WxStaticBoxSizer2->Add(EngineUpdates,1,wxEXPAND | wxALL,5);

	WxBoxSizer4 = new wxBoxSizer(wxVERTICAL);
	WxStaticBoxSizer2->Add(WxBoxSizer4, 2, wxEXPAND | wxALL, 5);

	WxBoxSizer5 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer4->Add(WxBoxSizer5, 1, wxEXPAND | wxALL, 5);

	WxStaticText1 = new wxStaticText(ControlsPage, ID_WXSTATICTEXT1, wxT("Name"), wxPoint(5,7), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxBoxSizer5->Add(WxStaticText1,0,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Name = new wxTextCtrl(ControlsPage, ID_NAME, wxT(""), wxPoint(47,5), wxSize(121,21), 0, wxDefaultValidator, wxT("Name"));
	WxBoxSizer5->Add(Name,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	WxBoxSizer6 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer4->Add(WxBoxSizer6, 1, wxEXPAND | wxALL, 5);

	WxStaticText2 = new wxStaticText(ControlsPage, ID_WXSTATICTEXT2, wxT("Exe"), wxPoint(5,9), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxBoxSizer6->Add(WxStaticText2,0,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Exe = new wxTextCtrl(ControlsPage, ID_EXE, wxT(""), wxPoint(37,7), wxSize(127,21), 0, wxDefaultValidator, wxT("Exe"));
	WxBoxSizer6->Add(Exe,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Browse = new wxButton(ControlsPage, ID_BROWSE, wxT("Browse"), wxPoint(174,5), wxSize(44,25), 0, wxDefaultValidator, wxT("Browse"));
	WxBoxSizer6->Add(Browse,0,wxALIGN_CENTER_VERTICAL | wxALL,5);

	WxBoxSizer7 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer4->Add(WxBoxSizer7, 1, wxEXPAND | wxALL, 5);

	WxStaticText3 = new wxStaticText(ControlsPage, ID_WXSTATICTEXT3, wxT("Parameters"), wxPoint(5,7), wxDefaultSize, 0, wxT("WxStaticText3"));
	WxBoxSizer7->Add(WxStaticText3,0,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Parameters = new wxTextCtrl(ControlsPage, ID_PARAMETERS, wxT(""), wxPoint(72,5), wxSize(121,21), 0, wxDefaultValidator, wxT("Parameters"));
	WxBoxSizer7->Add(Parameters,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	WxBoxSizer8 = new wxBoxSizer(wxHORIZONTAL);
	WxBoxSizer4->Add(WxBoxSizer8, 1, wxEXPAND | wxALL, 5);

	Update = new wxButton(ControlsPage, ID_UPDATE, wxT("Update"), wxPoint(5,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Update"));
	WxBoxSizer8->Add(Update,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	Reset = new wxButton(ControlsPage, ID_RESET, wxT("Reset"), wxPoint(90,5), wxSize(75,25), 0, wxDefaultValidator, wxT("Reset"));
	WxBoxSizer8->Add(Reset,1,wxALIGN_CENTER_VERTICAL | wxALL,5);

	DetailsPage = new wxPanel(Notebook, ID_DETAILSPAGE, wxPoint(4,24), wxSize(454,322));
	Notebook->AddPage(DetailsPage, wxT("Details"));

	WxBoxSizer9 = new wxBoxSizer(wxHORIZONTAL);
	DetailsPage->SetSizer(WxBoxSizer9);
	DetailsPage->SetAutoLayout(true);

	Details = new wxTextCtrl(DetailsPage, ID_DETAILS, wxT(""), wxPoint(5,5), wxSize(445,309), wxTE_READONLY | wxTE_RICH2 | wxTE_MULTILINE, wxDefaultValidator, wxT("Details"));
	Details->SetMaxLength(0);
	Details->SetFocus();
	Details->SetInsertionPointEnd();
	WxBoxSizer9->Add(Details,1,wxEXPAND | wxALL,5);

	Menu = new wxMenuBar();
	wxMenu *ID_MNU_FILE_1001_Mnu_Obj = new wxMenu(0);
	ID_MNU_FILE_1001_Mnu_Obj->Append(ID_MNU_FILE_EXIT_1002, wxT("E&xit\tAlt-F4"), wxT("Quit the application"), wxITEM_NORMAL);
	Menu->Append(ID_MNU_FILE_1001_Mnu_Obj, wxT("&File"));
	
	wxMenu *ID_MNU_TOOLS_1003_Mnu_Obj = new wxMenu(0);
	ID_MNU_TOOLS_1003_Mnu_Obj->Append(ID_MNU__ENGINEMANAGER_1004, wxT("&Engine Manager\tCtrl-E"), wxT(""), wxITEM_NORMAL);
	ID_MNU_TOOLS_1003_Mnu_Obj->Append(ID_MNU__TOURNAMENTMANAGER_CTRL_T_1007, wxT("&New Tournament\tCtrl-T"), wxT(""), wxITEM_NORMAL);
	ID_MNU_TOOLS_1003_Mnu_Obj->Append(ID_MNU__CONFIGURATION_F2_1008, wxT("&Configuration\tF2"), wxT(""), wxITEM_NORMAL);
	ID_MNU_TOOLS_1003_Mnu_Obj->Append(ID_MNU__SPLITPAIRINGWINDOWS_CTRL_S_1063, wxT("&Split Pairing Windows\tCtrl-S"), wxT(""), wxITEM_NORMAL);
	Menu->Append(ID_MNU_TOOLS_1003_Mnu_Obj, wxT("&Tools"));
	
	wxMenu *ID_MNU_HELP_1009_Mnu_Obj = new wxMenu(0);
	ID_MNU_HELP_1009_Mnu_Obj->Append(ID_MNU__ABOUT_1010, wxT("&About"), wxT(""), wxITEM_NORMAL);
	Menu->Append(ID_MNU_HELP_1009_Mnu_Obj, wxT("&Help"));
	SetMenuBar(Menu);

	WxSplitterWindow1->SplitVertically(Rounds,Pairings,137);

	SetTitle(wxT("PSWBTM"));
	SetIcon(wxNullIcon);
	
	GetSizer()->Fit(this);
	GetSizer()->SetSizeHints(this);
	Center();
	
	////GUI Items Creation End
}

void PSWBTMFrm::PSWBTMFrmClose(wxCloseEvent& event)
{
	if(t.isValid && t.running)
	{
		wxMessageBox(_T("Please Pause, Finish, or Abort the current tourney before exiting."), _T("Opps!"),wxOK | wxICON_INFORMATION, this);
		return;
	}
    Destroy();
}

/*
 * Mnufileexit1002Click
 */
void PSWBTMFrm::Mnufileexit1002Click(wxCommandEvent& event)
{
	if(t.isValid && t.running)
	{
		wxMessageBox(_T("Please Pause, Finish, or Abort the current tourney before exiting."), _T("Opps!"),wxOK | wxICON_INFORMATION, this);
		return;
	}
	Destroy();
}

/*
 * Mnuabout1010Click
 */
void PSWBTMFrm::Mnuabout1010Click(wxCommandEvent& event)
{
	wxString msg;
	msg.Printf
	(
		_T("Pradu's Simple Winboard Tournament Manager\n")
		_T(VERSION_STRING)
        _T("\n")
        #ifdef OLIVIER_VERSION
            _T("Olivier Version\n")
        #endif
		_T("Copywright (C) 2006 Pradyumna (Pradu) Kannan\n")
	);
	wxMessageBox(msg, _T("About PSWBTM"),wxOK | wxICON_INFORMATION, this); 
}

/*
 * Mnuenginemanager1004Click
 */
void PSWBTMFrm::Mnuenginemanager1004Click(wxCommandEvent& event)
{
	EngineManager em(NULL);
	em.ShowModal();
	return;
}

/*
 * Mnuconfigurationf21008Click
 */
void PSWBTMFrm::Mnuconfigurationf21008Click(wxCommandEvent& event)
{
	Configuration config(NULL);
	config.ShowModal();
	return;
}

/*
 * Mnutournamentmanagerctrlt1007Click
 */
void PSWBTMFrm::Mnutournamentmanagerctrlt1007Click(wxCommandEvent& event)
{
	if(t.isValid)
	{
		wxMessageBox(_T("Sorry, you cannot start a new tourney until the current one finished or aborted."), _T("Opps!"),wxOK | wxICON_INFORMATION, this);
		return;
	}
	NewTournament nt(NULL);
	nt.ShowModal();
	t.read();
	(t.Participants).updateControl(*EngineUpdates);
	updateGUI();
	return;
}

/*
 * BrowseClick
 */
void PSWBTMFrm::BrowseClick(wxCommandEvent& event)
{
	wxFileDialog fd(this, "Choose the Engine Executable","","","Windows Executables (*.exe)|*.exe|Other|*.*",wxOPEN |wxFILE_MUST_EXIST);
	if(fd.ShowModal()==wxID_OK)
		Exe->SetValue(fd.GetPath());
}

/*
 * Mnusplitpairingwindowsctrls1063Click
 */
void PSWBTMFrm::Mnusplitpairingwindowsctrls1063Click(wxCommandEvent& event)
{
	if(!(WxSplitterWindow1->IsSplit()))
		WxSplitterWindow1->SplitVertically(Rounds,Pairings,137);
}

/*
 * RoundsSelected
 */
void PSWBTMFrm::RoundsSelected(wxCommandEvent& event)
{
	int i=Rounds->GetSelection();
	if(i==wxNOT_FOUND) i=0;
	t.updatePairingDisplay(*Rounds,*Pairings,i);
}

/*
 * PauseClick
 */
void PSWBTMFrm::PauseClick(wxCommandEvent& event)
{
	if(!t.isValid) return;
	if(!t.running)
	{
        #ifdef OLIVIER_VERSION
            t.tries_left=NUM_TRIES;
		#endif
        t.run();
		if(t.running)
			PR->SetLabel("Pause");
		return;
	}
	if(t.status==Tournament::STATUS_NONE)
	{
		t.status=Tournament::STATUS_PENDING_PAUSE;
		PR->SetLabel("Cancel Pause");
		return;
	}
	if(t.status==Tournament::STATUS_PENDING_PAUSE)
	{
		t.status=Tournament::STATUS_NONE;
		if(t.running)
			PR->SetLabel("Pause");
		return;
	}
}

/*
 * KillPauseClick
 */
void PSWBTMFrm::KillPauseClick(wxCommandEvent& event)
{              
	t.killPause();
	PR->SetLabel("Resume");
}

/*
 * AbortClick
 */
void PSWBTMFrm::AbortClick(wxCommandEvent& event)
{
    if(wxYES==wxMessageBox(wxString("Are you sure you want to abort?"),wxString("Aborting tourney..."),wxYES_NO))
	{
         t.killPause();
	     t.finish();
    }
}

/*
 * PERClick
 */
void PSWBTMFrm::PERClick(wxCommandEvent& event)
{
	t.pauseEveryRound=PER->GetValue();
}

void PSWBTMFrm::updateInfo(wxCommandEvent& event)
{
	updateGUI();
}

void PSWBTMFrm::updateGUI()
{
	if(!t.isValid)
	{
		this->SetTitle(wxT("PSWBTM"));
		Rounds->Disable();
		Pairings->Disable();
		
		//Tournament Controls
		PR->Disable();
		KillPause->Disable();
		Abort->Disable();
		PER->Disable();
		
		//Engine Updates
		EngineUpdates->Disable();
		Update->Disable();
		Reset->Disable();
		Name->Disable();
		Exe->Disable();
		Parameters->Disable();
		Browse->Disable();
		
		t.updateStandings(*Standings);
		return;
	}
	
	//Enable All
	Rounds->Enable();
	Pairings->Enable();
	
	//Tournament Controls
	PR->Enable();
	KillPause->Enable();
	Abort->Enable();
	PER->Enable();
	
	t.updateStandings(*Standings);
	t.updatePairingDisplay(*Rounds,*Pairings,t.roundNum(t.currentPairing));
	Rounds->Select(t.roundNum(t.currentPairing));
	t.updateDetails(*Details);
	if(t.running)
	{
		KillPause->Enable();
		this->SetTitle(wxT("PSWBTM - Tournament Running"));	
		
		//Engine Updates
		EngineUpdates->Disable();
		Update->Disable();
		Reset->Disable();
		Name->Disable();
		Exe->Disable();
		Parameters->Disable();
		Browse->Disable();
		
		switch(t.status)
		{
			case Tournament::STATUS_NONE:
				PR->SetLabel("Pause");
				break;
			case Tournament::STATUS_PENDING_PAUSE:
				PR->SetLabel("Cancel Pause");
		}
	}
	else
	{
		KillPause->Disable();
		
		//Engine Updates
		EngineUpdates->Enable();
		Update->Enable();
		Reset->Enable();
		Name->Enable();
		Exe->Enable();
		Parameters->Enable();
		Browse->Enable();
		
		this->SetTitle(wxT("PSWBTM - Tournament Paused"));
		PR->SetLabel("Resume");
		//Enable/Disables
	}
}

/*
 * EngineUpdatesSelected
 */
void PSWBTMFrm::EngineUpdatesSelected(wxCommandEvent& event)
{
	int i=EngineUpdates->GetSelection();
	if(i==wxNOT_FOUND) return;
	Name->SetValue((t.Participants[i]).name);
	Exe->SetValue(((t.Participants[i]).exe).GetFullPath());
	Parameters->SetValue((t.Participants[i]).parameters);
}

/*
 * UpdateClick
 */
void PSWBTMFrm::UpdateClick(wxCommandEvent& event)
{
	int i=EngineUpdates->GetSelection();
	if(i==wxNOT_FOUND) return;
	Engine e(Name->GetLineText(0),Exe->GetLineText(0),Parameters->GetLineText(0));
	
	//update RTPGN File
	if(t.RTPGN!=wxEmptyString)
	{
		FILE* RTPGN_old=fopen((t.RTPGN).c_str(),"r");
		if(RTPGN_old!=NULL)
		{
			FILE* RTPGN_new=fopen("tempRTPGN.pswbtm","w");
			char line[4096];
			while(fgets(line,4096,RTPGN_old))
			{
				wxString Line(line);
				if(Line.Contains((t.Participants[i]).name))
				{
					if(Line.StartsWith("[White"))
						sprintf(line,"[White \"%s\"]\n",(e.name).c_str());
					else if(Line.StartsWith("[Black"))
						sprintf(line,"[Black \"%s\"]\n",(e.name).c_str());
				}
				fprintf(RTPGN_new,line);
			}
			fclose(RTPGN_old);
			fclose(RTPGN_new);
			wxCopyFile(wxString("tempRTPGN.pswbtm"),t.RTPGN);
			wxRemoveFile("tempRTPGN.pswbtm");
		}
	}
	
	t.Participants[i]=e;
	t.createPairings();
	(t.Participants).writeTournamentFile();
	(t.Participants).updateControl(*EngineUpdates);
	updateGUI();
}
