#include "Pairing.h"

Pairing::Pairing(const Engine& firstChessProgram, const Engine& secondChessProgram)
{
	fcp=firstChessProgram;
	scp=secondChessProgram;
}

Pairing::Pairing(const Pairing& p)
{
	operator=(p);
}

Pairing& Pairing::operator=(const Pairing& p)
{
	fcp=p.fcp;
	scp=p.scp;
	return *this;
}

wxString Pairing::getWBparameters(int gameToPlay)
{
	if(gameToPlay%2)
		return scp.getWBParameters(Engine::WHITE)+" "+fcp.getWBParameters(Engine::BLACK);
	return fcp.getWBParameters(Engine::WHITE)+" "+scp.getWBParameters(Engine::BLACK);
}

Engine Pairing::White(int gameToPlay)
{
	if(gameToPlay%2) return scp;
	return fcp;
}

Engine Pairing::Black(int gameToPlay)
{
	if(gameToPlay%2) return fcp;
	return scp;
}
